#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		daemon		%{name}d
#-----------------------------------------------------------------------------
Name		:	dhcp
Version		:	4.4.3
Release		:	14.4.0.0%{?dist}
Summary		:	Dynamic host configuration protocol software

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	ISC
URL		:	ftp://ftp.isc.org/isc/dhcp/

Source0		:	%{name}-%{version}.tar.gz
Source1		:	%{name}-ok_addon.tar.gz

Requires	:	%{name}-common		=  %{version}-%{release}

#-----------------------------------------------------------------------------
%description
DHCP (Dynamic Host Configuration Protocol) is a protocol which allows
individual devices on an IP network to get their own network
configuration information (IP address, subnetmask, broadcast address,
etc.) from a DHCP server. The overall purpose of DHCP is to make it
easier to administer a large network.  The dhcp package includes the
ISC DHCP service and relay agent.

To use DHCP on your network, install a DHCP service (or relay agent),
and on clients run a DHCP client daemon.  
The dhcp package provides only developpement file.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%{_includedir}/dhcpctl/*.h
%{_includedir}/omapip/*.h
%{_mandir}/man3/dhcpctl.3.gz
%{_mandir}/man3/omapi.3.gz


#=============================================================================
%package		common

Summary		:	Common files used by ISC dhcp client and server
Group		:	System Environment/Base

#--------------------------------------------------------------------
Requires(pre)	:	shadow
#--------------------------------------------------------------------
%description		common
DHCP (Dynamic Host Configuration Protocol) is a protocol which allows
individual devices on an IP network to get their own network
configuration information (IP address, subnetmask, broadcast address,
etc.) from a DHCP server. The overall purpose of DHCP is to make it
easier to administer a large network.

This package provides common files used by dhcp-server and
dhcp-client package.

#--------------------------------------------------------------------
%files			common
%defattr(-,root,root,-)
%doc LICENSE README
%{_libdir}/lib*.a
%{_mandir}/man5/dhcp-options.5.gz
%{_mandir}/man5/dhcp-eval.5.gz

%pre			common
/usr/bin/getent group %{daemon} >/dev/null || 
  /usr/sbin/groupadd				\
	-K GID_MIN=50				\
	-K GID_MAX=99				\
	 %{daemon}
/usr/bin/getent passwd %{daemon} >/dev/null || 
  /usr/sbin/useradd 				\
	-r					\
	-c "dhcp server"			\
	-K SYS_UID_MIN=50			\
	-K SYS_UID_MAX=99			\
	-g %{daemon}				\
	-s /sbin/nologin			\
	-d %{_var}/privsep/%{daemon}		\
	%{daemon}

%postun			common
if [ "$1" = 0 ]; then
  /usr/sbin/userdel %{daemon}
  /usr/sbin/groupdel %{daemon}
  (
  /bin/echo -n "%{name}-%{version} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-removed
  fi

#=============================================================================
%package		client

Summary		:	Provides the ISC DHCP client daemon and client-script
Group		:	System Environment/Base

Requires	:	%{name}-common		= %{version}-%{release}
Requires	:	iproute2
Requires	:	lfs-bootscripts

#-----------------------------------------------------------------------------
%description		client
DHCP (Dynamic Host Configuration Protocol) is a protocol which allows
individual devices on an IP network to get their own network
configuration information (IP address, subnetmask, broadcast address,
etc.) from a DHCP server. The overall purpose of DHCP is to make it
easier to administer a large network.

The client package provides the ISC DHCP client daemon.

#-----------------------------------------------------------------------------
%files			client
%defattr(-,root,root,-)
%attr(0600,root,root) %config(noreplace) %{_sysconfdir}/%{name}/dhclient.conf
%attr(0700,root,root) %config(noreplace) %{_sysconfdir}/%{name}/dhclient-enter-hooks
%attr(0700,root,root) %config(noreplace) %{_sysconfdir}/%{name}/dhclient-exit-hooks
%attr(0700,root,root) %config(noreplace) %{_sysconfdir}/sysconfig/dhclient
%{_sysconfdir}/%{name}/dhclient.conf.example
%{_sbindir}/dhclient
%{_sbindir}/dhclient-script
%{_mandir}/man5/dhclient.conf.5.gz
%{_mandir}/man5/dhclient.leases.5.gz
%{_mandir}/man8/dhclient-script.8.gz
%{_mandir}/man8/dhclient.8.gz
%dir %{_var}/lib/dhclient

#=============================================================================
%package		server
Summary		:	Provides the DHCP client daemon
Group		:	System Environment/Base

Requires	:	%{name}-common		= %{version}-%{release}
Requires	:	lfs-bootscripts
Requires	:	chkconfig

#-----------------------------------------------------------------------------
%description		server
DHCP (Dynamic Host Configuration Protocol) is a protocol which allows
individual devices on an IP network to get their own network
configuration information (IP address, subnetmask, broadcast address,
etc.) from a DHCP server. The overall purpose of DHCP is to make it
easier to administer a large network.

The server package provides the ISC DHCP server daemon.

#-----------------------------------------------------------------------------
%files			server
%defattr(-,root,root,-)
%{_sysconfdir}/%{name}/dhcpd.conf.example
%attr(0750,-,-) %{_sysconfdir}/rc.d/init.d/%{daemon}
%config(noreplace) %{_sysconfdir}/sysconfig/%{daemon}
%attr(0750,-,-) %{_sysconfdir}/rc.d/init.d/%{daemon}6
%config(noreplace) %{_sysconfdir}/sysconfig/%{daemon}6
%attr(-,%{daemon},%{daemon}) %dir %{_var}/lib/%{daemon}
%attr(-,%{daemon},%{daemon}) %{_var}/lib/%{daemon}/%{daemon}.leases
%attr(-,%{daemon},%{daemon}) %{_var}/lib/%{daemon}/%{daemon}6.leases
%{_bindir}/omshell
%{_sbindir}/%{daemon}
%{_sbindir}/%{daemon}6
%{_sbindir}/dhcrelay
%{_mandir}/man1/omshell.1.gz
%{_mandir}/man5/dhcpd.conf.5.gz
%{_mandir}/man5/dhcpd.leases.5.gz
%{_mandir}/man8/dhcpd.8.gz
%{_mandir}/man8/dhcrelay.8.gz

#after upgrade or remove
%preun			server
if [ "$1" = 0 ]; then
  %{_sysconfdir}/rc.d/init.d/%{daemon} stop > /dev/null 2>&1 || :
  /sbin/chkconfig --del %{daemon}
  (
  /bin/echo -n "%{name}-server-%{version} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-removed
  fi

%post			server
/sbin/chkconfig --add %{daemon} 
/sbin/chkconfig --add %{daemon}6
%{_sysconfdir}/rc.d/init.d/%{daemon} condrestart > /dev/null 2>&1 || :
%{_sysconfdir}/rc.d/init.d/%{daemon}6 condrestart > /dev/null 2>&1 || :

#=============================================================================
%prep
%setup -q

#First, fix a build issue with GCC 10 and later:
sed -i								\
  -e '/o.*dhcp_type/d'						\
  server/mdb.c

sed -i -r							\
  -e '/u.*(local|remote)_port/d'				\
  client/dhclient.c 						\
  relay/dhcrelay.c

#---------------------------------------------------------
#building application
%build

%{__tar} xf %{SOURCE1}

sed -i								\
  -e "s:/etc/dhclient-:/etc/dhcp/dhclient-:"			\
  client/scripts/linux
  
(								\
export CFLAGS="$CFLAGS -Wall -fno-strict-aliasing		\
  -D_PATH_DHCLIENT_SCRIPT='\"%{_sbindir}/dhclient-script\"'	\
  -D_PATH_DHCPD_CONF='\"/etc/%{name}/dhcpd.conf\"'		\
  -D_PATH_DHCLIENT_CONF='\"/etc/%{name}/dhclient.conf\"'	\
  "
./configure							\
        --prefix=%{_prefix}					\
	--exec-prefix=%{_exec_prefix}				\
        --sysconfdir=%{_sysconfdir}/%{name}			\
        --sbindir=%{_sbindir}					\
	--mandir=%{_mandir}					\
	--libdir=%{_libdir}					\
	--infodir=%{_infodir}					\
	--sharedstatedir=%{_var}/lib				\
	--localstatedir=%{_localstatedir}			\
	--docdir=%{_defaultdocdir}/%{name}-%{version}		\
	--enable-dhcpv6						\
	--enable-paranoia					\
	--enable-log-pid					\
	--with-srv-pid-file=%{_localstatedir}/run/dhcpd.pid	\
    	--with-srv6-pid-file=%{_localstatedir}/run/dhcpd6.pid	\
	--with-srv-lease-file=/var/lib/dhcpd/dhcpd.leases       \
	--with-srv6-lease-file=/var/lib/dhcpd/dhcpd6.leases     \
	--with-cli-lease-file=/var/lib/dhclient/dhclient.leases \
	--with-cli6-lease-file=/var/lib/dhclient/dhclient6.leases
)

#dhcpd can't be compiled multi-thread
%define _smp_mflags -j1
%{__make} %{_smp_mflags}

%clean
%{__rm} -rf %{buildroot}

#installing program
%install

%{__rm} -rf %{buildroot}

%{__make}							\
	DESTDIR=%{buildroot}					\
	install
install -m0755							\
	%{name}-ok_addon/dhclient-script.linux			\
	%{buildroot}%{_sbindir}/dhclient-script

#linking dhcpd to dhcpd6 daemon
%{__ln_s}							\
	./%{daemon}						\
	%{buildroot}%{_sbindir}/%{daemon}6

#taking care of client side
cp -a								\
	%{name}-ok_addon/dhclient-*-hooks			\
	%{name}-ok_addon/dhclient.conf				\
	%{buildroot}%{_sysconfdir}/%{name}

%{__mkdir_p}							\
	%{buildroot}%{_var}/lib/dhclient

#taking care of server side
%{__mkdir_p}							\
	%{buildroot}%{_sysconfdir}/rc.d/init.d			\
	%{buildroot}%{_sysconfdir}/sysconfig

cp -a								\
	%{name}-ok_addon/%{daemon}				\
	%{name}-ok_addon/%{daemon}6				\
	%{buildroot}%{_sysconfdir}/rc.d/init.d		

cp -a								\
	%{name}-ok_addon/%{daemon}.sysconfig			\
	%{buildroot}%{_sysconfdir}/sysconfig/%{daemon}

cp -a	%{name}-ok_addon/%{daemon}6.sysconfig			\
	%{buildroot}%{_sysconfdir}/sysconfig/%{daemon}6

cp -a	%{name}-ok_addon/dhclient.sysconfig			\
	%{buildroot}%{_sysconfdir}/sysconfig/dhclient

%{__mkdir_p}							\
	%{buildroot}%{_var}/lib/%{daemon}

touch								\
	%{buildroot}%{_var}/lib/%{daemon}/%{daemon}.leases	\
	%{buildroot}%{_var}/lib/%{daemon}/%{daemon}6.leases

#-----------------------------------------------------------------------------
%changelog
